(function () {
    "use strict";

    angular.module('core').controller('notaFiscalController', controller);
    controller.$inject = ['$scope', '$q', '$state', '$stateParams', '$alert', 'notaFiscalService', 'entradaService', 'Upload'];

    function controller($scope, $q, $state, $stateParams, $alert, notaFiscalService, entradaService, Upload) {
        $scope.initializeLayout('Notas Fiscais');

        //[Inicializa objetos]
        $scope.state = {
            data: [],
            carregando: false,
            vazio: false,
            count: 0,
            filtro: {
                ativo: false,
                args: {
                    chaves: '',
                    filtro: {},
                    sortExpression: '',
                    skip: 0,
                    take: 20
                }
            }
        };
        $scope.popups = {
            add: {
                ativo: false,
                toggle: function () {
                    $scope.popups.add.ativo = !$scope.popups.add.ativo;
                }
            },
        }

        //[Inicializa funcões]
        $scope.initialize = async () => {
            await $scope.clearFilter();

            const _filtro = $scope.localStorage.getItem('state.filtro.args');
            if (_filtro) {
                await angular.copy(_filtro, $scope.state.filtro.args);
            }

            if ($stateParams.id)
                $scope.popups.edit.toggle($stateParams.id);

            $scope.refresh();
        };

        $scope.beforeRefresh = async () => {
            await $scope.convertFilter();
        };
        $scope.afterRefresh = async () => {
            /* trata mudanças no filtro */
            $scope.state.filtro.original.sortExpression = $scope.state.filtro.args.sortExpression;
            $scope.state.filtro.original.skip = $scope.state.filtro.args.skip;
            $scope.state.filtro.original.take = $scope.state.filtro.args.take;

            $scope.state.filtro.hasChanges = (angular.toJson($scope.state.filtro.original) !== angular.toJson($scope.state.filtro.args));

            /* armazena na localstorage para quando inicializar a página */
            $scope.localStorage.setItem('state.filtro.args', $scope.state.filtro.args);
        };
        $scope.refresh = async () => {
            try {
                await $scope.beforeRefresh();
                $scope.state.filtro.ativo = false;
                await $scope.innerRefresh();
                await $scope.afterRefresh();
            }
            catch (error) {
                console.error(error);
                $scope.clearFilter();
            } finally {
                $scope.$digest();
            }
        };
        $scope.clear = async () => {
            await $scope.clearFilter();
            $scope.refresh();
        };

        $scope.toggleFilter = async () => {
            $scope.state.filtro.ativo = !$scope.state.filtro.ativo;
        };
        $scope.convertFilter = async () => {
            /* prepara o filtro. Ex: in list de status */
        };
        $scope.clearFilter = async () => {
            $scope.state.filtro = {
                args: {
                    chaves: '',
                    filtro: null,
                    filtroDe: null,
                    filtroAte: null,
                    filtroEm: null,
                    sortExpression: '[CriadoEm] desc',
                    skip: 0,
                    take: 20,
                },
                original: {},
                hasChanges: false
            };

            await $scope.convertFilter();
            await angular.copy($scope.state.filtro.args, $scope.state.filtro.original);
        };

        $scope.innerRefresh = async () => {
            await $scope.getAll();
            await $scope.count();
        };
        $scope.getAll = async () => {
            try {
                $scope.state.filtro.args.skip = 0;
                $scope.state.carregando = true;
                $scope.state.completo = false;
                $scope.state.vazio = false;

                const response = await notaFiscalService.getAll($scope.state.filtro.args);
                if (response.Status < 0) {
                    $scope.tools.toastr.error(response.Message, 'Serviço');
                } else {
                    angular.copy(angular.fromJson(response.Data), $scope.state.data);
                }
                $scope.state.vazio = ($scope.state.data == 0);
            }
            catch (err) {
                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                console.error(err)
            }
            finally {
                $scope.state.carregando = false;
            }
        };
        $scope.count = async () => {
            try {
                const response = await notaFiscalService.count($scope.state.filtro.args);

                if (response.Status < 0) {
                    $scope.tools.toastr.error(response.Message, 'Serviço');
                } else {
                    $scope.state.count = response.Data;
                }
            }
            catch (err) {
                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                console.error(err)
            } finally {
            }
        };
        $scope.getMore = async () => {
            if (!$scope.state.carregandoMais && !$scope.state.carregando && !$scope.state.completo && !($scope.state.data == 0)) {
                try {
                    $scope.state.carregandoMais = true;
                    $scope.state.filtro.args.skip += $scope.state.filtro.args.take;

                    let response = await notaFiscalService.getAll($scope.state.filtro.args)
                    if (response.Status < 0) {
                        $scope.tools.toastr.error(response.Message, 'Serviço');
                    } else {
                        $scope.state.data = $scope.state.data.concat(response.Data);
                        $scope.state.completo = (response.Data == 0);
                    }
                } catch (err) {
                    $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                    console.error(err);
                } finally {
                    $scope.state.carregandoMais = false;
                    $scope.$digest();
                }
            }
        };

        $scope.downloadAllXml = async () => {
            try {
                if ($scope.state.downloading)
                    return;

                $scope.state.downloading = true;

                const response = await notaFiscalService.downloadAllXml($scope.state.filtro.args);

                if (!response.data.byteLength) {
                    $alert({ text: "Não foram encontrados XMLs com o filtro especificado." });
                } else {
                    var blob = new Blob([response.data], { type: response.headers("content-type") });
                    var fileName = response.headers("content-disposition").toLowerCase().replace("attachment; filename=", "");

                    if (navigator.msSaveOrOpenBlob) {
                        navigator.msSaveOrOpenBlob(blob, fileName);
                    } else {
                        var a = document.createElement("a");
                        var url = window.URL.createObjectURL(blob);

                        document.body.appendChild(a);
                        a.href = url;
                        a.download = fileName;
                        a.style = "display:none";
                        a.click();

                        window.URL.revokeObjectURL(url);
                        a.remove();
                    }
                }

            } catch (error) {
                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                console.error(error);
            } finally {
                $scope.state.downloading = false;
                $scope.$digest();
            }
        };
        $scope.openupload = function () {
            document.getElementById('fileXml').click()
        }
        $scope.enviarxml = function (file) {

            if (angular.isUndefined(file)) return;
            $scope.state.carregando = true;
            entradaService.prepareXml($scope.state.item).then(function () {
                file.upload = Upload.upload({
                    url: '/entrada/CreaeNotaFiscalXml',
                    data: { file: file }
                });

                file.upload.then(function (response) {

                    if (response.data.Status < 0)
                        $scope.tools.toastr.error(response.data.Message, "Atenção");
                    else {

                        if (response.data.Data != null && response.data.Data.Codigo != "");

                        $state.go("state-nota-fiscal-detail", { id: response.data.Data.ID });

                        //     $scope.tools.toastr.success("Informação", "Nota Fiscal Gerada com Sucesso.");

                    }
                    $scope.state.carregando = false;

                }, function (response) {
                    $scope.state.carregando = false;
                    $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                });

            });
        }

        /*Inicializa funções*/
        $scope.initialize();

    }

})();